/*
 * Copyright (c) 2001,2002 Andrew McGill and Leading Edge Business Solutions
 *
 * fake pop3 daemon
 *
 * fakepop is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * fakepop is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * fakepop; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: fakepop.c,v 1.2 2004/02/13 11:30:11 andrewm Exp $ */

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
extern int errno;		/* just in case */
#include <signal.h>
#include <time.h>

/* Autologout timer */
#define TIMEOUT (60)


/* Size of temporary buffers */
#define TMPLEN 1024


/* Hang up */
void bye(void)
{
	fflush(stdout);
	exit(0);
}

/* What we do when we time out */
void sigalarm (int whatever)
{
	fputs ("-ERR session timed out\r\n",stdout);
	fflush(stdout);	
	bye();
}

/* Lie to stdout in POP3 */
int main (int argc,char *argv[])
{
	char buffer[TMPLEN];
	char *command;
	char *argument;

	if (isatty(0)) {
		fputs("Welcome to fakepop "
			VERSION
			" where you will never get mail\n", stderr);
	}

	signal(SIGALRM,sigalarm);
	alarm(TIMEOUT);
	fputs ("+OK POP3 with no mail\r\n",stdout);
	while (1) {
		fflush(stdout);
		command=fgets(buffer,sizeof(buffer),stdin);
		alarm(TIMEOUT);
		if (command==NULL) {
			if (ferror (stdin)) { /* errno == EINTR? special treatment? */
				clearerr (stdin);
				fputs("-ERR interrupted\r\n",stdout);
				bye();
			}
			fputs("+OK Don't say bye then\r\n",stdout);
			bye();

		}
		else if (!strchr (buffer,'\r') && !strchr(buffer,'\n')) {	/* find end of line */
			fputs("-ERR too much on one line\r\n",stdout);
			bye();
		}

	        if ((command=strtok (buffer," \r\n"))==NULL) { /* null terminate the string */
			fputs ("-ERR Missing command! This server does nothing alreay\r\n",stdout);
			continue;
		}
		argument=strtok(NULL,"\r\n ");
		if (strcasecmp(command,"CAPA")==0 ) {
			fputs("+OK Capabilities include\r\nUSER\r\nPATHOLOGICAL-LYING\r\n.\r\n",stdout);
		}
		else if (strcasecmp(command,"USER")==0) {
			fputs("+OK that's a nice name\r\n",stdout);
		}
		else if (strcasecmp(command,"PASS")==0 ) {
			fputs("+OK nice password, but you've got 0 messages\r\n",stdout);
		}
		else if (strcasecmp(command,"LAST")==0 ) {
			fputs("+OK 0\r\n",stdout);
		}
		else if (strcasecmp(command,"STAT")==0) {
			fputs("+OK 0 0\r\n",stdout);
		}
		else if (strcasecmp(command,"LIST")==0 ||
			 strcasecmp(command,"UIDL")==0) {
			if (argument==NULL) {
				fputs("+OK No messages, really\r\n.\r\n",stdout);
			}
			else {
				fputs("+ERR No messages, no list, no status\r\n",stdout);
			}
		}
		else if (strcasecmp(command,"UIDL")==0) {
			fputs("+OK No unique IDs\r\n.\r\n",stdout);
		}
		else if (strcasecmp(command,"RSET")==0) {
			fputs("+OK Resetting or something\r\n.\r\n",stdout);
		}
		else if (strcasecmp(command,"NOOP")==0) {
			fputs("+OK Nothing successfully done\r\n.\r\n",stdout);
		}
		else if (strcasecmp(command,"RETR")==0 ||
			strcasecmp(command,"TOP")==0 ) {
			fputs("-ERR you got no messages\r\n",stdout);
		}
		else if (strcasecmp(command,"DELE")==0) {
			fputs("-ERR you canna delete what you aint got\r\n",stdout);
		}
		else if (strcasecmp(command,"QUIT")==0) {
			fputs("+OK cheers then\r\n",stdout);
			bye();
		}
		else {
			fputs("-ERR this server is too stupid for that\r\n",stdout);
		}
	}
	fputs ("-ERR what happened there?\r\n",stdout);
	bye();
	return(0);
}

