#! /bin/bash
# 
# Set up a proxy which will make every server out there a fake pop3 server
#
# Corresponding inetd lines is:
# 2500    stream  tcp     nowait  root    /usr/sbin/tnobody  /usr/local/bin/redirproxy -u /usr/local/bin/fakepop

DPORT=2500
IP="192.168.0.1"   # an IP address on this server

iptables -t nat -F
for PORT in 110; do
	iptables -t nat -D PREROUTING -p tcp --dport $PORT -j DNAT --to $IP:$DPORT
	iptables -t nat -I PREROUTING -p tcp --dport $PORT -j DNAT --to $IP:$DPORT
done

for PORT in $DPORT; do
	iptables -D INPUT -p tcp --dport $PORT -d $IP -j ACCEPT
	iptables -I INPUT -p tcp --dport $PORT -d $IP -j ACCEPT
done

echo 1 > /proc/sys/net/ipv4/ip_forward
